import SwiftUI
import Defaults

extension AppState {
	private func migrateToWebsiteStruct() {
		guard let url = Defaults[.url] else {
			return
		}

		Defaults[.url] = nil

		WebsitesController.shared.add(
			Website(
				id: UUID(),
				isCurrent: true,
				url: url.normalized(),
				usePrintStyles: false,
				css: Defaults[.customCSS],
				invertColors: Defaults[.invertColors]
			)
		)
	}

	private func migrateToAddTitle() {
		for website in WebsitesController.shared.allBinding {
			WebsitesController.shared.fetchTitleIfNeeded(for: website)
		}
	}

	private func migrateToWebsiteWithInvertColorsEnum() {
		for website in WebsitesController.shared.allBinding {
			website.wrappedValue.invertColors2 = website.wrappedValue.invertColors ? .always : .never
		}
	}

	func migrate() {
		migrateToWebsiteStruct()
		migrateToAddTitle()
		migrateToWebsiteWithInvertColorsEnum()
	}
}
